package dev.pfaff.log4truth.compat.log4j;

import dev.pfaff.log4truth.NamedLogger;
import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.Marker;
import org.apache.logging.log4j.message.Message;
import org.apache.logging.log4j.spi.AbstractLogger;

import java.util.List;

public final class Log4JToL4TLogger extends AbstractLogger {
	private final NamedLogger logger;

	public Log4JToL4TLogger(NamedLogger logger) {
		this.logger = logger;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, Message message, Throwable t) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, CharSequence message, Throwable t) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, Object message, Throwable t) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Throwable t) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Object... params) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Object p0) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Object p0, Object p1) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Object p0, Object p1, Object p2) {
		return true;
	}

	@Override
	public boolean isEnabled(Level level, Marker marker, String message, Object p0, Object p1, Object p2, Object p3) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level, Marker marker, String message, Object p0, Object p1, Object p2, Object p3, Object p4) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level,
			Marker marker,
			String message,
			Object p0,
			Object p1,
			Object p2,
			Object p3,
			Object p4,
			Object p5) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level,
			Marker marker,
			String message,
			Object p0,
			Object p1,
			Object p2,
			Object p3,
			Object p4,
			Object p5,
			Object p6) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level,
			Marker marker,
			String message,
			Object p0,
			Object p1,
			Object p2,
			Object p3,
			Object p4,
			Object p5,
			Object p6,
			Object p7) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level,
			Marker marker,
			String message,
			Object p0,
			Object p1,
			Object p2,
			Object p3,
			Object p4,
			Object p5,
			Object p6,
			Object p7,
			Object p8) {
		return true;
	}

	@Override
	public boolean isEnabled(
			Level level,
			Marker marker,
			String message,
			Object p0,
			Object p1,
			Object p2,
			Object p3,
			Object p4,
			Object p5,
			Object p6,
			Object p7,
			Object p8,
			Object p9) {
		return true;
	}

	@Override
	public void logMessage(String fqcn, Level level, Marker marker, Message message, Throwable t) {
		//noinspection ConstantValue
		if (marker != null) {
			logger.log(message::getFormattedMessage, t, List.of(level.name(), markerToTag(marker)));
		} else {
			logger.log(message::getFormattedMessage, t, List.of(level.name()));
		}
	}

	private static String markerToTag(Marker marker) {
		if (marker.getParents().length > 0) {
			return markerToTag(marker.getParents()[0]) + '/' + marker.getName();
		} else {
			return marker.getName();
		}
	}

	@Override
	public Level getLevel() {
		return Level.ALL;
	}
}
