package dev.pfaff.log4truth.compat.log4j;

import dev.pfaff.log4truth.NamedLogger;
import org.apache.logging.log4j.message.MessageFactory;
import org.apache.logging.log4j.spi.ExtendedLogger;
import org.apache.logging.log4j.spi.LoggerContext;

public final class Log4JToL4TLoggerContext implements LoggerContext {
	static final Log4JToL4TLoggerContext INSTANCE = new Log4JToL4TLoggerContext();

	private Log4JToL4TLoggerContext() {}

	@Override
	public Object getExternalContext() {
		return null;
	}

	@Override
	public ExtendedLogger getLogger(String name) {
		return new Log4JToL4TLogger(new NamedLogger(name));
	}

	@Override
	public ExtendedLogger getLogger(String name, MessageFactory messageFactory) {
		return getLogger(name);
	}

	@Override
	public boolean hasLogger(String name) {
		return false;
	}

	@Override
	public boolean hasLogger(String name, Class<? extends MessageFactory> messageFactoryClass) {
		return false;
	}

	@Override
	public boolean hasLogger(String name, MessageFactory messageFactory) {
		return false;
	}
}
